//BrainStrom mkH

import java.util.*;
import java.io.*;

class XML
{
	
	//Attribute
	public String safelastchar="";                  //  zuletzt gelesenes Zeichen 
	public int internalcounter=0;                   //  Zeiger auf aktuelles Zeichen 
	public int maxbytes=0;                   		 	//  Gesamtanzahl der Zeichen 
	public Vector vectorarray= new Vector(1,1);     //  Dateipuffer 	
	BufferedWriter f;						 
	FileReader f1;
	
	//Methoden	
	
	/*
	Beim Lesen benutzen wir:
	Class InputStreamReader
	read
	public int read() throws IOException
	Read a single character.
	Overrides:
	read in class Reader
	Returns:
	The character read, or -1 if the end of the stream has been reached
	Throws:
	IOException - If an I/O error occurs
	*/
	
	public void loadXml(File filename)
	{	
		int i=0;
		Character cc;
		vectorarray=new Vector(1,1);
		maxbytes=0;
		internalcounter=0;		
		
		try 
		{
			f1 = new FileReader(filename);
			while ( (i=f1.read()) != -1 )
			{
				cc=new Character((char)i);
				vectorarray.addElement(cc.toString());
				maxbytes=maxbytes+1;				
			}  				
			f1.close();
		} 
		catch (IOException e) 
		{
			System.out.println("Methode loadXml: Fehler beim Lesen der Datei");
		}							
		if (maxbytes==0)
		{
			safelastchar="";
		}
		else
		{				
			safelastchar   = ((String)vectorarray.get(0)); // lies erstes Zeichen 
			internalcounter=internalcounter+1;       		  // naechstes Zeichen 
		}
	}

	public void saveXml(File filename)
	{
		int counter=0;		
		try 
		{
			f = new BufferedWriter(new FileWriter(filename));
			while(counter < internalcounter)
			{				
				f.write((String) vectorarray.get(counter));				
				counter=counter+1;				
			}  				
			f.close();
		} 
		catch (IOException e) 
		{
			System.out.println("Methode saveXml: Fehler beim Erstellen der Datei");
		}				
		maxbytes           =0;                            
		internalcounter    =0;                            
	}
	
	
	//hier drfen nur Strings c von der Lnge 1 bergeben werden !!!
	//Da wir dadurch Character simulieren
	public void writeChar(String c) 
	{      
		if (internalcounter >= maxbytes)
		{          
			vectorarray.addElement(c);                 // hinzufuegen 
			maxbytes=maxbytes+1;							
		}
		else
		{			
			vectorarray.setElementAt(c,internalcounter);  // ueberschreiben 
		}
		internalcounter=internalcounter+1;					
	}
	
	public void writeTab()
	{
		for(int i=1;i<=8;i++)
		{
			writeChar(" ");
		}
	}
	
	public void writeTag(String tag,int leerzeichen) 
	{              		
		Character cc;
		while (leerzeichen > 0) //fr's Einrcken, damit's besser aussieht
		{
			if(leerzeichen > 8) 
			{  
				writeTab();                           // schreibe Tabulator 
				leerzeichen=leerzeichen-8;
			}
			else
			{    
				writeChar(" ");                            // schreibe Spacebar 
				leerzeichen=leerzeichen-1;
			}
		} 
		
		writeChar("<");                                    // Taganfang         	
		
		for(int i=0;i<tag.length();i++) // schreibe Tag in Kleinbuchstaben 
		{		
			cc=new Character(tag.charAt(i));
			writeChar( (cc.toString()).toLowerCase() );
		}			
		writeChar(">");                                     // Tagende 
	} 	
	
	
	public void writeString(String wstring)
	{
		Character cc;
		for(int count=0;count<wstring.length();count++)
		{          
			cc=new Character(wstring.charAt(count));
			if ( (cc.toString()).equals("&") ) // wandle & in &amp; um                   
			{                        
				writeChar("&");
				writeChar("a");
				writeChar("m");
				writeChar("p");
				writeChar(";");
			}
			else
			{
				if ( (cc.toString()).equals("<") ) // wandle < in &lt; um 
				{                      					
					writeChar("&");
					writeChar("l");
					writeChar("t");
					writeChar(";");
				}
				else
				{
					writeChar( cc.toString() );
				}
			}
		} 
	}
	
	
	public void resetXml()
	{	
		internalcounter=0;
	}
	
	public String getChar()
	{	
		if (internalcounter >= maxbytes) 
		{		
			System.out.println("Methode getChar: Unerwartetes Dateiende");
			System.exit(1);
		}
		else
		{
			safelastchar=((String) vectorarray.get(internalcounter));
			internalcounter=internalcounter+1;
		}
		return safelastchar;
	}
	
	
	public String lastChar()
	{
		return safelastchar;
	}
	
	
	public String getTag()
	{	
		String c="";                              // gelesenes Zeichen 
		String tstring="";                     // erzeugter Tagstring 
		int    count=0;                       // Laenge des Tags 
		
		c=lastChar();                     // auch c=safelastchar moeglich 	
		while ( !c.equals("<") ) c=getChar();     // berlese Zeichen bis Taganfang 	
		while ( (!c.equals(">")) && (!c.equals(" ")) )// Lese Zeichen bis Tagende 
		{					
			c=getChar();
			
			if( (!c.equals(">")) && (!c.equals(" ")) )
			{
				c=c.toLowerCase();             // wandle um in Kleinbuchstaben ,, machen Probleme und abgefahrene Sonderzeichen sicher auch...
				tstring=tstring+c;            // fge ein Zeichen zum String hinzu 
				count=count+1;
			}
			
		} 
		while ( !c.equals(">") )
		{
			c=getChar();    // berspringe alles bis ">"
		}
		c=getChar();
		return tstring;
	} // getTag 
	
	
	public String getString(String endtag)
	{		
		String  c="";                              // eingelesens Zeichen 
		int     count=0;                       // Anzahl Zeichen pro String 
		String  gstring="";                    // gelesener String 
		int     ampcount=0;                       // Anzahl Zeichen pro Sonderzeichenstring 
		String  amp="";                            // gelesener Sonderzeichenstring 
		
		
		c=lastChar();                     // letzte Zeichen nochmal holen 
		while (!c.equals("<"))
		{	
			if (c.equals("&")) // Sonderzeichen "&lt;" "&amp;" 
			{                     		
				amp     ="";                   // setze string auf leer 
				ampcount=0;
				c=getChar();              // lies neues Zeichen 
				while( !c.equals(";") )
				{
					if (ampcount > 3) // maximale Laenge 3 oder sonstwas 
					{          				
						System.out.println("Methode getString: Unbekanntes Sonderzeichen");
						System.exit(1);
					}
					else
					{
						amp       =amp+c;        // fge ein Zeichen zum String hinzu 
						ampcount  =ampcount+1;   // zhle Anzahl der Zeichen hoch 
					}
					c=getChar();             // hole neues Zeichen 
				} 
				
				if (amp.equals("lt"))
				{ 
					c="<";       // "<" Zeichen 
				}				
				else
				{
					if (amp.equals("amp")) 
					{ 
						c="&";      // "&" Zeichen 
					}
					else
					{				
						System.out.println("Methode getString:	Unbekanntes Sonderzeichen");
						System.exit(1);
					}
				} 	
			}			
			gstring =gstring+c;            // fge ein Zeichen zum String hinzu 
			count   =count+1;              // zhle Anzahl der Zeichen hoch 
			c=getChar();			
			
		}
		if ( !getTag().equals("/" + endtag) ) 
		{			
			System.out.println("Methode getString: Endtag passt nicht zum Anfangstag");
			System.out.println("Endtag sollte sein: /"+endtag);
			System.out.println("nexttag ist : "+getTag());
			System.exit(1);
		}			
		return gstring;
	}
	
	public void skipTag(String endtag)
	{		
		Vector vector=new Vector(1,1);
		String tag="";		
		Character cc;
		
		cc=new Character(endtag.charAt(0));
		if ( (cc.toString()).equals("/") )
		{                          		
			System.out.println("Methode skipTag: Fehler! falsches Endtag, Endtag gefunden ohne Anfangstag");			
			System.exit(1);
		}
		
		vector.addElement(endtag);		
		
		while (vector.size()!=0)
		{
			tag=getTag();
			cc=new Character(tag.charAt(0));
			if ( (cc.toString()).equals("/") )			// erste Zeichen des Strings 
			{                        
				tag=tag.substring(1); // schneide "/" vorne ab 
				if ( !tag.equals((String) vector.lastElement()) )  // vergleiche mit letztem vector 			
				{       
					System.out.println("Methode skipTag: Fehler! falsches Endtag, Endtag gefunden ohne Anfangstag");
					System.exit(1);
				}
				else 
				{
					vector.removeElementAt(vector.lastIndexOf(vector.lastElement()));// loesche letztes Element 
					vector.trimToSize();
				}
			}
			else
			{
				vector.addElement(tag);                 // fuege neues Tag hinzu 
			}
		}	
	}	
}

