//BrainStrom mkH

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.*;
import java.lang.Math;
import java.io.*;

class Info
{
	
	//Attribute 
	String aufrufklasse;
	String info_name;
	String filename;
	String info_version;
	String erstellungsdatum;
	String aenderungsdatum;
	String info_autor;
	String info_firma;
	String kommentar;
	
	
	//Konstruktor 
	public Info()
	{
		aufrufklasse="";
		info_name="";
		filename="";
		info_version="";
		erstellungsdatum="";
		aenderungsdatum="";
		info_autor="";
		info_firma="";
		kommentar="";
	}
	
	//Methode: editieren
	public void edit(String fenstertitel,String aufrufer)
	{
		aufrufklasse=aufrufer;
		Gui_Info klasse_info_gui = new Gui_Info(fenstertitel);
		klasse_info_gui.setVisible(true);
		klasse_info_gui.pack();			
	}
	
	//Methode: write: schreibt InfoDaten in ein XML-Objekt
	public void write(XML xmlobject)
	{		
		xmlobject.writeTag("header",2);         
		xmlobject.writeChar("\n");
		
		xmlobject.writeTag("name",4);
		xmlobject.writeString(info_name);
		xmlobject.writeTag("/name",0);          
		xmlobject.writeChar("\n");
		
		xmlobject.writeTag("filename",4);
		xmlobject.writeString(filename);
		xmlobject.writeTag("/filename",0);      
		xmlobject.writeChar("\n");
		
		xmlobject.writeTag("version",4);
		xmlobject.writeString(info_version);
		xmlobject.writeTag("/version",0);       
		xmlobject.writeChar("\n");
		
		xmlobject.writeTag("date",4);
		xmlobject.writeString(erstellungsdatum);
		xmlobject.writeTag("/date",0);          
		xmlobject.writeChar("\n");
		
		xmlobject.writeTag("lastchanged",4);
		xmlobject.writeString(aenderungsdatum);
		xmlobject.writeTag("/lastchanged",0);   
		xmlobject.writeChar("\n");
		
		xmlobject.writeTag("author",4);
		xmlobject.writeString(info_autor);
		xmlobject.writeTag("/author",0);        
		xmlobject.writeChar("\n");
		
		xmlobject.writeTag("company",4);
		xmlobject.writeString(info_firma);
		xmlobject.writeTag("/company",0);       
		xmlobject.writeChar("\n");
		
		xmlobject.writeTag("comment",4);
		xmlobject.writeString(kommentar);
		xmlobject.writeTag("/comment",0);       
		xmlobject.writeChar("\n");
		
		xmlobject.writeTag("/header",2);        
		xmlobject.writeChar("\n");		
	}
	
	
	//Methode: read: liest InfoDaten von einem XML-Objekt
	public void read(XML xmlobject)
	{              
		String tag="";		   
		while (!tag.equals("/header"))		
		{
			tag=xmlobject.getTag();
			if (tag.equals("name")) info_name=xmlobject.getString("name");		         
			else
			{
				if (tag.equals("filename")) filename=xmlobject.getString("filename");		           
				else
				{
					if (tag.equals("version")) info_version=xmlobject.getString("version");		             
					else
					{						
						if (tag.equals("date")) erstellungsdatum=xmlobject.getString("date");		               
						else
						{							
							if (tag.equals("lastchanged")) aenderungsdatum=xmlobject.getString("lastchanged");		                 
							else
							{								
								if (tag.equals("author")) info_autor=xmlobject.getString("author");
								else
								{									
									if (tag.equals("company")) info_firma=xmlobject.getString("company");
									else
									{
										if (tag.equals("comment")) kommentar=xmlobject.getString("comment");		                   
										else
										{											
											if (!tag.equals("/header")) xmlobject.skipTag(tag);
										}
									}
								}
							}
						}									
					}				
				}				
			}				
		}							
	}						
	
	//GUI
	public class Gui_Info extends JFrame 
	{
		
		ImageIcon frameImageIcon = new ImageIcon("brain.jpg");
		Image frameImage = frameImageIcon.getImage();
		
		JPanel contentPane = new JPanel();
		
		JPanel allgemeinPane = new JPanel();
		JPanel buttonPane = new JPanel();
		
		JPanel name1 = new JPanel();
		JPanel file1 = new JPanel();
		JPanel version1 = new JPanel();
		JPanel erstdatum1 = new JPanel();
		JPanel aenderdatum1 = new JPanel();
		JPanel autor1 = new JPanel();
		JPanel firma1 = new JPanel();
		JPanel beschr1 = new JPanel();
		
		JTextField name = new JTextField(info_name,40);
		JTextField file = new JTextField(filename,40);
		JTextField version = new JTextField(info_version,40);
		JTextField erstdatum = new JTextField(erstellungsdatum,40);
		JTextField aenderdatum = new JTextField(aenderungsdatum,40);
		JTextField autor = new JTextField(info_autor,40);
		JTextField firma = new JTextField(info_firma,40);
		JTextField beschr = new JTextField(kommentar,40);
		
		JButton ok = new JButton("OK");
		JButton abbrechen = new JButton("Abbrechen");
		
		ActionListener on_buttons = new ButtonsListener();
		
		//Construct the frame
		public Gui_Info(String fenstertitel)
		{
			enableEvents(AWTEvent.WINDOW_EVENT_MASK);
			try
			{
				init(fenstertitel);
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		
		//Component initialization von Gui_Info
		private void init(String fenstertitel)
		{
			this.setIconImage(frameImage);
			this.setContentPane(contentPane);
			this.setSize(new Dimension(600,600));
			this.setTitle("Informationen editieren");
			
			contentPane.setLayout(new BorderLayout());
			contentPane.add(allgemeinPane, BorderLayout.NORTH);
			contentPane.add(buttonPane, BorderLayout.SOUTH);
			
			allgemeinPane.setLayout(new GridLayout(8,1));
			allgemeinPane.setBorder(new TitledBorder(fenstertitel));
			
			allgemeinPane.add(name1);
			allgemeinPane.add(file1);
			allgemeinPane.add(version1);
			allgemeinPane.add(erstdatum1);
			allgemeinPane.add(aenderdatum1);
			allgemeinPane.add(autor1);
			allgemeinPane.add(firma1);
			allgemeinPane.add(beschr1);
			
			name1.setLayout(new BorderLayout());                     //Allgemein...
			name1.add(new JLabel("Name:"), BorderLayout.NORTH);
			name1.add(name, BorderLayout.SOUTH);
			file1.setLayout(new BorderLayout());
			file1.add(new JLabel("Filename:"));
			file1.add(file, BorderLayout.SOUTH);
			version1.setLayout(new BorderLayout());
			version1.add(new JLabel("Version:"), BorderLayout.NORTH);
			version1.add(version, BorderLayout.SOUTH);
			erstdatum1.setLayout(new BorderLayout());
			erstdatum1.add(new JLabel("Erstellungsdatum:"), BorderLayout.NORTH);
			erstdatum1.add(erstdatum, BorderLayout.SOUTH);
			aenderdatum1.setLayout(new BorderLayout());
			aenderdatum1.add(new JLabel("nderungsdatum"), BorderLayout.NORTH);
			aenderdatum1.add(aenderdatum, BorderLayout.SOUTH);
			autor1.setLayout(new BorderLayout());
			autor1.add(new JLabel("Autor"), BorderLayout.NORTH);
			autor1.add(autor, BorderLayout.SOUTH);
			firma1.setLayout(new BorderLayout());
			firma1.add(new JLabel("Firma"), BorderLayout.NORTH);
			firma1.add(firma, BorderLayout.SOUTH);
			beschr1.setLayout(new BorderLayout());
			beschr1.add(new JLabel("Beschreibung/Kommentar"), BorderLayout.NORTH);
			beschr1.add(beschr, BorderLayout.SOUTH);
			
			buttonPane.setLayout(new BorderLayout());
			buttonPane.add(ok, BorderLayout.WEST);
			buttonPane.add(abbrechen, BorderLayout.EAST);
			
			ok.addActionListener(on_buttons);   
			abbrechen.addActionListener(on_buttons);
		}
		
		//Overridden so we can exit when window is closed
		protected void processWindowEvent(WindowEvent e)
		{
			super.processWindowEvent(e);
			if (e.getID() == WindowEvent.WINDOW_CLOSING)
			{
				this.dispose();
			}
		}
		
		public class ButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{	
				if(e.getActionCommand()=="OK")
				{ 	
					info_name=name.getText();
					filename=file.getText();
					info_version=version.getText();
					erstellungsdatum=erstdatum.getText();
					aenderungsdatum=aenderdatum.getText();
					info_autor=autor.getText();
					info_firma=firma.getText();
					kommentar=beschr.getText();							
					if (aufrufklasse=="klasse")    Klasse.klasse_info_offen=false;
					if (aufrufklasse=="usecase")   UseCase.usecase_info_offen=false;
					if (aufrufklasse=="ph")        Pflichtenheft.ph_info_offen=false;
					if (aufrufklasse=="verbindung")Verbindung.verbindung_info_offen=false;
					if (aufrufklasse=="objekt")    Objekt.objekt_info_offen=false;													
					dispose();
				}
				
				if(e.getActionCommand()=="Abbrechen")
				{
					if (aufrufklasse=="klasse")    Klasse.klasse_info_offen=false;
					if (aufrufklasse=="usecase")   UseCase.usecase_info_offen=false;
					if (aufrufklasse=="ph")        Pflichtenheft.ph_info_offen=false;
					if (aufrufklasse=="verbindung")Verbindung.verbindung_info_offen=false;
					if (aufrufklasse=="objekt")    Objekt.objekt_info_offen=false;							
					dispose();
					
				}
			}
		}    		
	}		
}//Info.ENDE
