//BrainStrom mkH

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import java.util.*;
import java.io.*;

class Pflichtenheft
{	
	
	//Attribute
	static boolean ph_info_offen;
	Info pflichtenheft_info;
	String pflichten_name;
	String pflichten_text;
	
	//Konstruktor
	public Pflichtenheft()
	{
		ph_info_offen=false;
		pflichtenheft_info=new Info();
		pflichten_name="";
		pflichten_text="";
	}
	
	//Methode: editieren
	public void edit()
	{
		Gui_Pflichtenheft pflichtenheft_gui = new Gui_Pflichtenheft();
		pflichtenheft_gui.setVisible(true);
		pflichtenheft_gui.pack();
	}
	
	//Methode: save
	public void save(File filename)
	{
		System.out.println("Speichern");
	}
	
	//Methode: laden
	public void lade(File file)
	{
		System.out.println("Lade FILE "+file.getPath());
		UMLTOPP.ph_offen=false;
	}
	
	//GUI
	private class Gui_Pflichtenheft extends JFrame 
	{
		final JFileChooser fc = new JFileChooser();
		
		JPanel contentPane = new JPanel();
		JPanel allgemeinPane = new JPanel();
		JPanel allgemein1 = new JPanel();
		JPanel allgemein2 = new JPanel();
		
		JTextField pflichtenheft_name_txtfield = new JTextField(20);
		
		JButton info = new JButton("Info");
		
		JPanel defaultPane = new JPanel();
		Vector default_text = new Vector();
		JTextArea pflichtenheft_text = new JTextArea();
		JScrollPane scroll_pflichtenheft = new JScrollPane(pflichtenheft_text);
		
		JPanel buttonPane = new JPanel();
		JButton ok = new JButton("OK");
		JButton abbrechen = new JButton("Abbrechen");
		
		ActionListener on_buttons = new ButtonsListener();
		
		//Construct the frame
		public Gui_Pflichtenheft()
		{
			enableEvents(AWTEvent.WINDOW_EVENT_MASK);
			try
			{
				init();
			}
			
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		
		//Component initialization
		private void init()
		{
			this.setContentPane(contentPane);
			this.setSize(new Dimension(600,600));
			this.setTitle("Pflichtenheft editieren");
			this.setIconImage((new ImageIcon("brain.jpg")).getImage());
			
			contentPane.setLayout(new BorderLayout());
			contentPane.add(allgemeinPane, BorderLayout.NORTH);
			contentPane.add(defaultPane, BorderLayout.CENTER);
			contentPane.add(buttonPane, BorderLayout.SOUTH);
			
			//Allgemein
			allgemeinPane.setLayout(new BorderLayout());                     
			allgemeinPane.setBorder(new TitledBorder("Allgemein"));
			allgemeinPane.add(allgemein1, BorderLayout.EAST);
			allgemeinPane.add(allgemein2, BorderLayout.WEST);
			
			allgemein1.setLayout(new BorderLayout());
			allgemein1.add(info, BorderLayout.EAST);
			allgemein1.add(allgemein2, BorderLayout.WEST);
			
			allgemein2.setLayout(new BorderLayout());
			allgemein2.add(new JLabel("Name des Pflichtenheftes:"), BorderLayout.WEST);
			allgemein2.add(pflichtenheft_name_txtfield, BorderLayout.EAST);           
			//Allgemein.ENDE
			
			scroll_pflichtenheft.setPreferredSize(new Dimension(500, 550));
			allgemein1.add(scroll_pflichtenheft, BorderLayout.SOUTH);
			
			buttonPane.setLayout(new BorderLayout());
			buttonPane.add(ok, BorderLayout.WEST);
			buttonPane.add(abbrechen, BorderLayout.EAST);
			
			pflichtenheft_text.setTabSize(2);
			pflichtenheft_text.append("1) Zielbestimmungen:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\t" + "1.1) Mubestimmungen:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\t" + "1.2) Kannbestimmungen:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\t" + "1.3) Abgrenzungen:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("2) Produkteinsatz:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\t" + "2.1) Anwendungsbereiche:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\t" + "2.2) Zielgruppen:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\t" + "2.3) Betriebsbedingungen:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("3) Produktumgebung:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\t" + "3.1) Software:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\t" + "3.2) Hardware:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\t" + "3.3) Orgware:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\t" + "3.4) Schnittstellen:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("4) Produktinformation:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("5) Produktdaten:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("6) Leistungen:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("7) Benutzeroberflche:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("8) Qualittsziele:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("9) Testszenarien:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("10) Entwicklungsumgebung:");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("\n");
			pflichtenheft_text.append("11) Ergnzungen:");
			
			info.addActionListener(on_buttons);
			ok.addActionListener(on_buttons);
			abbrechen.addActionListener(on_buttons);
			
			setVisible(true);
			pack();
		}
		
		protected void processWindowEvent(WindowEvent e)
		{
			super.processWindowEvent(e);
			if (e.getID() == WindowEvent.WINDOW_CLOSING)
			{
				UMLTOPP.ph_offen=false;
				this.dispose();
			}
		}
		
		public class ButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{	
				if(e.getActionCommand()=="Info")
				{ 
					if (ph_info_offen==false)
					{
						pflichten_name=pflichtenheft_name_txtfield.getText();
						ph_info_offen=true;
						pflichtenheft_info.edit("Informationen des Pflichtenhefts: "+pflichten_name,"ph");
					}
					else
					{;
					}
				}
				
				if(e.getActionCommand()=="OK")
				{ 
					//interne Speicherung
					pflichten_name=pflichtenheft_name_txtfield.getText();
					pflichten_text=pflichtenheft_text.getText();
					
					fc.setDialogTitle("Pflichtenheft speichern");
					File default_file=new File("Pflichtenheft "+pflichten_name+".xml");
					fc.setSelectedFile(default_file);
					int returnVal =fc.showSaveDialog(Gui_Pflichtenheft.this);
					if(returnVal == JFileChooser.APPROVE_OPTION)
					{
						File file = fc.getSelectedFile();
						save(file);	
						UMLTOPP.ph_offen=false;
						dispose();				
					}						
				}	
				
				if(e.getActionCommand()=="Abbrechen")
				{
					UMLTOPP.ph_offen=false;
					dispose();
				}
			}
		}	
	}      
}
