//BrainStrom mkH

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import java.lang.Math;
import java.util.*;
import java.io.*;

class Verbindung
{
	
	//Attribute
	static boolean verbindung_info_offen;
	Info header;
	String verbindung_name;
	String beschriftung;
	String stereotyp;
	String zusicherung;
	Knoten knoten1,knoten2;
	
	//Konstruktor
	Verbindung()
	{
		verbindung_info_offen=false;
		header = new Info();
		stereotyp = "";
		verbindung_name = "";
		zusicherung = "";
		knoten1 = new Knoten();
		knoten2 = new Knoten();
	}
	
	//Methode: editieren
	public void edit()
	{
		Gui_Verbindungen my_verbindungen_gui = new Gui_Verbindungen();
		my_verbindungen_gui.setVisible(true);
		my_verbindungen_gui.pack();
	}
	
	//Methode: save
	public void save(File filename)
	{
		System.out.println("Speichern");
	}
	
	//Methode: laden
	public void lade(File file)
	{
		System.out.println("Lade FILE "+file.getPath());
		UMLTOPP.verbindung_offen=false;
	}
	
	//Datentyp: Knoten
	class Knoten
	{
		String pfeiltyp;
		String multiplikator;
		String zusicherung_knoten;
		
		Knoten()
		{
			pfeiltyp= "";
			multiplikator="";
			zusicherung_knoten="";}
	}
	
	//GUI
	class Gui_Verbindungen extends JFrame
	{		
		final JFileChooser fc = new JFileChooser();
		
		JPanel content_pane = new JPanel();
		
		JPanel left = new JPanel();
		JPanel right = new JPanel();
		
		JPanel right_buttons = new JPanel();
		
		JPanel one1 = new JPanel();
		JPanel one11 = new JPanel();
		JPanel oneall = new JPanel();
		
		JPanel two1 = new JPanel();
		JPanel two2 = new JPanel();
		JPanel two3 = new JPanel();
		JPanel two4 = new JPanel();
		JPanel twoall = new JPanel();
		
		JPanel three1 = new JPanel();
		JPanel three2 = new JPanel();
		JPanel three3 = new JPanel();
		JPanel threeall = new JPanel();
		
		JPanel four1 = new JPanel();
		JPanel four2 = new JPanel();
		JPanel four3 = new JPanel();
		JPanel fourall = new JPanel();
		
		JPanel left2 = new JPanel();
		
		JSplitPane my_splitter = new JSplitPane(1, left, right);
		
		//TextFields des Reiters "Allgemein"
		JTextField connection_name = new JTextField(10);
		
		
		
		JTextField indication = new JTextField(10);
		JTextField stereotype = new JTextField(10);
		JTextField indication_assurance = new JTextField(10);
		String text,stereotyp,zusicherung,zahl_links,zusicherung_links,zahl_rechts,zusicherung_rechts;			           
		int indicator,indicator2,indicator3,j;
		int[] a,b,c,d;
		FontMetrics m ;
		//TextFields des Reiters "Links/Oben"
		JTextField left_top_number = new JTextField(10);
		JTextField left_top_assurance = new JTextField(10);
		
		//TextFields des Reiters "Rechts/Unten"
		JTextField right_down_number = new JTextField(10);
		JTextField right_down_assurance = new JTextField(10);
		
		JButton info = new JButton("Info");
		
		JButton right_button1 = new JButton("Anzeigen");
		JButton right_button2 = new JButton("OK");
		JButton right_button3 = new JButton("Abbrechen");
		
		MyCanvas paint_canvas = new MyCanvas();
		
		
		JComboBox scope_linetype = new JComboBox();
		JComboBox scope_left_top_arrowtype = new JComboBox();
		JComboBox scope_right_down_arrowtype = new JComboBox();
		//JComboBox right_detail = new JComboBox();
		
		//JTextArea text_area1 = new JTextArea(5, 15);
		
		ActionListener on_right_buttons = new RightButtonsListener();
		
		//Construct the frame
		public Gui_Verbindungen()
		{
			enableEvents(AWTEvent.WINDOW_EVENT_MASK);
			try
			{
				init();
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		/* static int max(int a,int s,int d){
		if(a>s){if (a>d) return a; else return d;}
		else {if (s>d) return s; else return d;}}*/
		
		//Component initialization
		private void init()
		{
			this.setContentPane(content_pane);
			this.setSize(new Dimension(400,300));
			this.setTitle("Verbindung editieren");
			this.setIconImage((new ImageIcon("brain.jpg")).getImage());
			
			content_pane.add(my_splitter);
			
			left.setLayout(new BorderLayout());
			right.setLayout(new BorderLayout());
			
			paint_canvas.setSize(new Dimension(400,420));
			paint_canvas.setBackground(new Color(255, 255,255));
			
			scope_linetype.setBackground(new Color(255, 255, 255));
			scope_linetype.addItem("durchgezogen");
			scope_linetype.addItem("gestrichelt");
			
			
			scope_left_top_arrowtype.setBackground(new Color(255, 255, 255));
			scope_left_top_arrowtype.addItem("leer");
			scope_left_top_arrowtype.addItem("einfach");
			scope_left_top_arrowtype.addItem("Dreieck");
			scope_left_top_arrowtype.addItem("Dreieck-gefllt");
			scope_left_top_arrowtype.addItem("Raute");
			scope_left_top_arrowtype.addItem("Raute-gefllt");
			
			scope_right_down_arrowtype.setBackground(new Color(255, 255, 255));
			scope_right_down_arrowtype.addItem("leer");
			scope_right_down_arrowtype.addItem("einfach");
			scope_right_down_arrowtype.addItem("Dreieck");
			scope_right_down_arrowtype.addItem("Dreieck-gefllt");
			scope_right_down_arrowtype.addItem("Raute");
			scope_right_down_arrowtype.addItem("Raute-gefllt");
			
			/*right_detail.setBackground(new Color(255, 255, 255));
			right_detail.setToolTipText("Detailierungsgrad");
			right_detail.addItem("hoch");
			right_detail.addItem("mittel");
			right_detail.addItem("niedrig");*/
			
			one1.setLayout(new BorderLayout());
			one1.add(info, BorderLayout.EAST);
			one1.add(one11, BorderLayout.WEST);
			
			one11.setLayout(new GridLayout(1,2));
			one11.add(new JLabel("Name"));
			one11.add(connection_name);
			
			oneall.setPreferredSize(new Dimension(400,50));
			oneall.setLayout(new BorderLayout());
			oneall.setBorder(new TitledBorder("Allgemein"));
			oneall.add(one1, BorderLayout.CENTER);
			
			
			two1.setLayout(new BorderLayout());
			two1.add(new JLabel("Bezeichnung:"),BorderLayout.WEST);
			two1.add(indication,BorderLayout.EAST);
			
			
			two2.setLayout(new BorderLayout());
			two2.add(new JLabel("Stereotyp:"), BorderLayout.WEST);
			two2.add(stereotype, BorderLayout.EAST);
			
			two3.setLayout(new BorderLayout());
			two3.add(new JLabel("Zusicherungen:"), BorderLayout.WEST);
			two3.add(indication_assurance, BorderLayout.EAST);
			
			two4.setLayout(new BorderLayout());
			two4.add(new JLabel("Linientyp:"),BorderLayout.WEST);
			two4.add(scope_linetype, BorderLayout.EAST);
			
			twoall.setLayout(new GridLayout(4,1));
			twoall.setBorder(new TitledBorder("Linie"));
			twoall.add(two1);
			twoall.add(two2);
			twoall.add(two3);
			twoall.add(two4);
			
			three1.setLayout(new BorderLayout());
			three1.add(new JLabel("Pfeilart:"),BorderLayout.WEST);
			three1.add(scope_left_top_arrowtype,BorderLayout.EAST);
			
			three2.setLayout(new BorderLayout());
			three2.add(new JLabel("Multiplizitt:"),BorderLayout.WEST);
			three2.add(left_top_number,BorderLayout.EAST);
			
			three3.setLayout(new BorderLayout());
			three3.add(new JLabel("Zusicherung:"),BorderLayout.WEST);
			three3.add(left_top_assurance,BorderLayout.EAST);
			
			threeall.setLayout(new GridLayout(3,1));
			threeall.setBorder(new TitledBorder("Linkes bzw oberes Pfeilende"));
			threeall.add(three1);
			threeall.add(three2);
			threeall.add(three3);
			
			four1.setLayout(new BorderLayout());
			four1.add(new JLabel("Pfeilart:"),BorderLayout.WEST);
			four1.add(scope_right_down_arrowtype,BorderLayout.EAST);
			
			four2.setLayout(new BorderLayout());
			four2.add(new JLabel("Multiplizitt:"),BorderLayout.WEST);
			four2.add(right_down_number,BorderLayout.EAST);
			
			four3.setLayout(new BorderLayout());
			four3.add(new JLabel("Zusicherung:"),BorderLayout.WEST);
			four3.add(right_down_assurance,BorderLayout.EAST);
			
			fourall.setLayout(new GridLayout(3,1));
			fourall.setBorder(new TitledBorder("Rechtes bzw unteres Pfeilende"));
			fourall.add(four1);
			fourall.add(four2);
			fourall.add(four3);
			
			
			left2.setLayout(new GridLayout(3,1));
			left2.add(twoall);
			left2.add(threeall);
			left2.add(fourall);
			
			left.add(oneall,BorderLayout.NORTH);
			left.add(left2,BorderLayout.SOUTH);
			
			right_buttons.setLayout(new GridLayout(0, 3));
			right_buttons.add(right_button1);
			//right_buttons.add(right_detail);
			right_buttons.add(right_button2);
			right_buttons.add(right_button3);
			
			right.add(paint_canvas, BorderLayout.NORTH);
			right.add(right_buttons, BorderLayout.SOUTH);
			
			info.addActionListener(on_right_buttons);
			right_button1.addActionListener(on_right_buttons);
			right_button2.addActionListener(on_right_buttons);
			right_button3.addActionListener(on_right_buttons);
		}
		
		public class RightButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(e.getActionCommand()=="Info")					
				{
					if (verbindung_info_offen==false)
					{
						verbindung_name=connection_name.getText();
						verbindung_info_offen=true;
						header.edit("Informationen der Verbindung: "+verbindung_name,"verbindung");
					}
					else
					{;
					}
				}
				
				
				
				if(e.getActionCommand()=="Anzeigen")
				{
					text = indication.getText();
					stereotyp = stereotype.getText();
					zusicherung = indication_assurance.getText();
					zahl_links = left_top_number.getText();
					zusicherung_links = left_top_assurance.getText();
					zahl_rechts = right_down_number.getText();
					zusicherung_rechts = right_down_assurance.getText();
					if(scope_linetype.getSelectedItem()=="durchgezogen"){indicator = 1;}
					if(scope_linetype.getSelectedItem()=="gestrichelt"){indicator = 2;}
					
					if(scope_left_top_arrowtype.getSelectedItem()=="leer"){indicator2 = 0;}
					if(scope_left_top_arrowtype.getSelectedItem()=="einfach"){indicator2 = 1;}
					if(scope_left_top_arrowtype.getSelectedItem()=="Dreieck"){indicator2 = 2;}
					if(scope_left_top_arrowtype.getSelectedItem()=="Dreieck-gefllt"){indicator2 = 3;}
					if(scope_left_top_arrowtype.getSelectedItem()=="Raute"){indicator2 = 4;}
					if(scope_left_top_arrowtype.getSelectedItem()=="Raute-gefllt"){indicator2 = 5;}
					
					if(scope_right_down_arrowtype.getSelectedItem()=="leer"){indicator3= 0;}
					if(scope_right_down_arrowtype.getSelectedItem()=="einfach"){indicator3= 1;}
					if(scope_right_down_arrowtype.getSelectedItem()=="Dreieck"){indicator3= 2;}
					if(scope_right_down_arrowtype.getSelectedItem()=="Dreieck-gefllt"){indicator3= 3;}
					if(scope_right_down_arrowtype.getSelectedItem()=="Raute"){indicator3= 4;}
					if(scope_right_down_arrowtype.getSelectedItem()=="Raute-gefllt"){indicator3= 5;}
					paint_canvas.repaint();
					
				}
				
				if(e.getActionCommand()=="OK")
				{					
					//interne Speicherung der allgemeinen Daten
					verbindung_name=connection_name.getText();
					stereotyp=stereotype.getText();
					beschriftung=indication.getText();
					zusicherung=indication_assurance.getText();
					//interne Speicherung des linken/oberen Knotens
					knoten1.pfeiltyp=scope_left_top_arrowtype.getSelectedItem().toString();
					knoten1.multiplikator=left_top_number.getText();
					knoten1.zusicherung_knoten=left_top_assurance.getText();
					//interne Speicherung des rechten/unteren Knotens
					knoten2.pfeiltyp=scope_right_down_arrowtype.getSelectedItem().toString();
					knoten2.multiplikator=right_down_number.getText();
					knoten2.zusicherung_knoten=right_down_assurance.getText();
					
					fc.setDialogTitle("Verbindung speichern");
					File default_file=new File("Verbindung "+verbindung_name+".xml");
					fc.setSelectedFile(default_file);
					int returnVal =fc.showSaveDialog(Gui_Verbindungen.this);					
					if(returnVal == JFileChooser.APPROVE_OPTION)
					{
						File file = fc.getSelectedFile();
						save(file);	
						UMLTOPP.verbindung_offen=false;
						dispose();				
					}						
				}
				
				if(e.getActionCommand()=="Abbrechen")
				{
					UMLTOPP.verbindung_offen=false;
					dispose();
				}
			}
		}
		
		//Overridden so we can exit when window is closed
		protected void processWindowEvent(WindowEvent e)
		{
			super.processWindowEvent(e);
			if (e.getID() == WindowEvent.WINDOW_CLOSING)
			{
				UMLTOPP.verbindung_offen=false;
				this.dispose();
			}
		}
		
		public class MyCanvas extends Canvas
		{
			MyCanvas()
			{
				setBackground(Color.white);
				setForeground(Color.black);
			}
			
			public void paint(Graphics g)
			{
				
				j=Math.max(Math.max(this.getFontMetrics(this.getFont()).stringWidth(text+zahl_links+zahl_rechts),
					this.getFontMetrics(this.getFont()).stringWidth(stereotyp+zahl_links+zahl_rechts)),
					this.getFontMetrics(this.getFont()).stringWidth(zusicherung+zahl_links+zahl_rechts))
					+70;
				if(stereotyp.length()>0){j=j+this.getFontMetrics(this.getFont()).stringWidth("<<>>");}
				if(zusicherung.length()>0){j=j+this.getFontMetrics(this.getFont()).stringWidth("{}");}
				
				if(indicator == 1)
				{
					g.drawLine(30,60,j,60);}
				if(indicator == 2)
				{	int i=30;
					while(i<j){
						g.drawLine(i,60,i+5,60);i=i+10;}  }
				if(text.length()> 0){
					g.drawString(text,this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50,40);}
				if(stereotyp.length()>0){
					g.drawString(stereotyp,this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50+
						this.getFontMetrics(this.getFont()).stringWidth("<<"),30);
					g.drawString("<<",this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50,30);
					g.drawString(">>", this.getFontMetrics(this.getFont()).stringWidth(stereotyp)+
						this.getFontMetrics(this.getFont()).stringWidth("<<")+
						this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50,30);}
				if(zusicherung.length()>0){
					g.drawString(zusicherung,this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50+
						this.getFontMetrics(this.getFont()).stringWidth("{"),50);
					g.drawString("{",this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50,50);
					g.drawString("}",this.getFontMetrics(this.getFont()).stringWidth(zusicherung)+
						this.getFontMetrics(this.getFont()).stringWidth("{")+
						this.getFontMetrics(this.getFont()).stringWidth(zahl_links)+50,50);}
				if(zahl_links.length()>0){
					g.drawString(zahl_links,40,50);}
				if(zahl_rechts.length()>0){
					g.drawString(zahl_rechts,j-this.getFontMetrics(this.getFont()).stringWidth(zahl_rechts)-10,50);}
				if(zusicherung_links.length()>0){
					g.drawString(zusicherung_links,40,70);}
				if(zusicherung_rechts.length()>0){
					g.drawString(zusicherung_rechts,j-this.getFontMetrics(this.getFont()).stringWidth(zahl_rechts)-10,80);}
				
				if(indicator2 == 0){}
				if(indicator2 == 1){
					g.drawLine(30,60,45,56);
					g.drawLine(30,60,45,64);}
				
				if(indicator2 == 2){
					a = new int[3];a[0]=15;a[1]=30;a[2]=30;
					b = new int[3];b[0]=60;b[1]=56;b[2]=64;
					g.drawPolygon(a,b,3);}
				if(indicator2 == 3){
					a = new int[3];a[0]=15;a[1]=30;a[2]=30;
					b = new int[3];b[0]=60;b[1]=56;b[2]=64;
					g.drawPolygon(a,b,3);
					g.fillPolygon(a,b,3);}
				if(indicator2 == 4){
					a = new int[4];a[0]=10;a[1]=20;a[2]=30;a[3]=20;
					b = new int[4];b[0]=60;b[1]=55;b[2]=60;b[3]=65;
					g.drawPolygon(a,b,4);}
				if(indicator2 == 5){
					a = new int[4];a[0]=10;a[1]=20;a[2]=30;a[3]=20;
					b = new int[4];b[0]=60;b[1]=55;b[2]=60;b[3]=65;
					g.drawPolygon(a,b,4);
					g.fillPolygon(a,b,4);}
				if(indicator3 == 0){}
				if(indicator3 == 1){
					g.drawLine(j,60,j-15,56);
					g.drawLine(j,60,j-15,64);}
				if(indicator3 == 2){
					a = new int[3];a[0]=j+15;a[1]=j;a[2]=j;
					b = new int[3];b[0]=60;b[1]=56;b[2]=64;
					g.drawPolygon(a,b,3);}
				if(indicator3 == 3){
					a = new int[3];a[0]=j+15;a[1]=j;a[2]=j;
					b = new int[3];b[0]=60;b[1]=56;b[2]=64;
					g.drawPolygon(a,b,3);
					g.fillPolygon(a,b,3);}
				if(indicator3 == 4){
					a = new int[4];a[0]=j;a[1]=j+10;a[2]=j+20;a[3]=j+10;
					b = new int[4];b[0]=60;b[1]=55;b[2]=60;b[3]=65;
					g.drawPolygon(a,b,4);}
				if(indicator3 == 5){
					a = new int[4];a[0]=j;a[1]=j+10;a[2]=j+20;a[3]=j+10;
					b = new int[4];b[0]=60;b[1]=55;b[2]=60;b[3]=65;
					g.drawPolygon(a,b,4);
					g.fillPolygon(a,b,4);
				}
			}
		}//Ende der Canvas 
	}//Ende GUI	
}//Ende Verbindung
